unit CurrentTrackInfoToFile_Defines;

interface

uses
  Windows,
  Menus,
  ComCtrls,
  Classes,
  {
  gnugettext,
  Locales,
  }
  AIMPSDKAddons,
  AIMPAddonCustomPlugin;

type
  TSettings = record
   Filename: WideString;
   Template: WideString;
  end;

  TObjProc = procedure of object;

  TEntries = record
   Playlist: HPLS;
   EntryIndex: Integer;
  end;

const
  //plugin data
  myPluginName = 'Current Track info to file';
  myPluginAuthor = 'Korney San';
  myPluginInfo = 'Puts current track info to text file.';

  //settings
  optFilename = 'Filename';
  optTemplate = 'Template';
  optLanguage = 'Language';

var
  StaticWideString: array [0..MAX_PATH-1] of WideChar;
  AIMPProfilePath: WideString = '';
  PluginsFolder: WideString = '';
  myPluginFolder: WideString = '';
  //myLocales: TLocales = nil;
  mySettings: TSettings = (Filename: ''; Template: '%R - %T');
  OnSettingsChange: TObjProc = nil;

procedure LoadSettings(const Plugin: TAIMPAddonsCustomPlugin; const Section: String; var Settings: TSettings);
procedure SaveSettings(const Plugin: TAIMPAddonsCustomPlugin; const Section: String; const Settings: TSettings);
procedure SettingsChanged(const Settings: TSettings);

implementation

procedure LoadSettings(const Plugin: TAIMPAddonsCustomPlugin; const Section: String; var Settings: TSettings);
begin
 if Assigned(Plugin) then
   with Plugin do
     with Settings do
      begin
       Filename:=ConfigReadString(Section, optFilename);
       Template:=ConfigReadString(Section, optTemplate);
       //Lang:=ConfigReadString(Section, optLanguage);
      end;
end;

procedure SaveSettings(const Plugin: TAIMPAddonsCustomPlugin; const Section: String; const Settings: TSettings);
begin
 if Assigned(Plugin) then
   with Plugin do
     with Settings do
      begin
       ConfigWriteString(Section, optFilename, Filename);
       ConfigWriteString(Section, optTemplate, Template);
       //ConfigWriteString(Section, optLanguage, Lang);
      end;
end;

procedure SettingsChanged(const Settings: TSettings);
begin
 with Settings do
  begin
   //UseLanguage(Lang);
  end;
 if Assigned(OnSettingsChange) then
   OnSettingsChange;
end;

end.
