unit CurrentTrackInfoToFile_SetupForm;

interface

uses
  AIMPAddonCustomPlugin,
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, JvExStdCtrls, JvEdit, Mask, JvExMask,
  JvToolEdit;

type
  TCTITF_SetupForm = class(TForm)
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    FE_File: TJvFilenameEdit;
    E_Template: TJvEdit;
    Label1: TLabel;
    Label2: TLabel;
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormShow(Sender: TObject);
    procedure E_TemplateChange(Sender: TObject);
  private
    { Private declarations }
    FPlugin: TAIMPAddonsCustomPlugin;
    procedure SetHint;
  public
    { Public declarations }
    property Plugin: TAIMPAddonsCustomPlugin read FPlugin write FPlugin default nil;
  end;

var
  SF: TCTITF_SetupForm = nil;

implementation

{$R *.dfm}

uses
  AIMPSDKAddons,
  CurrentTrackInfoToFile_Defines;

procedure BitBtnClick(const AForm: TForm; const BitBtn: TBitBtn);
begin
 if Assigned(AForm) and Assigned(BitBtn) then
  begin
   if BitBtn.Owner=AForm then
    begin
     AForm.ModalResult:=BitBtn.ModalResult;
       if not (fsModal in AForm.FormState) then
         AForm.Close;
    end;
  end;
end;

procedure TCTITF_SetupForm.BitBtn1Click(Sender: TObject);
begin
 BitBtnClick(Self, Sender as TBitBtn);
end;

procedure TCTITF_SetupForm.BitBtn2Click(Sender: TObject);
begin
 BitBtnClick(Self, Sender as TBitBtn);
end;

procedure TCTITF_SetupForm.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
 if ModalResult=mrOK then
  begin
   mySettings.Filename:=FE_File.Text;
   mySettings.Template:=E_Template.Text;
   if Assigned(FPlugin) then
     SaveSettings(Plugin, myPluginName, mySettings);
  end;
end;

procedure TCTITF_SetupForm.FormShow(Sender: TObject);
begin
 FE_File.Text:=mySettings.Filename;
 E_Template.Text:=mySettings.Template;
 SetHint;
end;

procedure TCTITF_SetupForm.SetHint;
var
  APlaylistManager: IAIMPAddonsPlaylistManager;
  w: WideString;
  wc: PWideChar;
begin
  if Plugin.GetPlaylistManager(APlaylistManager) then
  try
    w:=E_Template.Text;
    APlaylistManager.FormatString(PWideChar(w), Length(w), AIMP_PLAYLIST_FORMAT_MODE_PREVIEW, nil, wc);
    E_Template.Hint:=wc;
  finally
    APlaylistManager:=nil;
  end;
end;

procedure TCTITF_SetupForm.E_TemplateChange(Sender: TObject);
begin
 SetHint;
end;

end.
